import create from 'zustand'

const useStore = create(set => ({
  loggedIn: false,
  setLoggedIn: (loggedIn) => set(state => ({ loggedIn })),
  authToken: '',
  setAuthToken: (authToken) => set(state => ({ authToken })),
  ownerToken: '',
  setOwnerToken: (ownerToken) => set(state => ({ ownerToken })),
  isLoggingIn: false,
  setLoggingIn: (isLoggingIn) => set(state => ({ isLoggingIn })),
  loginError: '',
  setLoginError: (loginError) => set(state => ({ loginError })),
  firstName: '',
  setFirstName: (firstName) => set(state => ({ firstName })),
  password: '',
  setPassword: (password) => set(state => ({ password })),
  isUploading: false,
  uploadingCount: 0,
  setIsUploading: (isUploading) => set(state => ({ isUploading, uploadingCount: state.uploadingCount + isUploading ? 1 : -1 })),
  selectedPhotoIndex: -1,
  setSelectedPhotoIndex: (index) => set(state => ({ selectedPhotoIndex: index })),
  myPhotos: [],
  setMyPhotos: myPhotos => set(state => ({ myPhotos })),
  photos: [],
  setPhotos: (photos) => set(state => ({ photos })),
  addPhoto: (photo) => set(state => {
    const photos = state.photos;
    photos.splice(0, 0, photo);
    return { photos };
  }),
  nextPhoto: null,
  setNextPhoto: (nextPhoto) => set(state => ({ nextPhoto })),
  endReached: false,
  setEndReached: (endReached) => set(state => ({ endReached })),
}));
export default useStore;
